# Software Freedom Camp Website

This website is build using [Hugo](https://gohugo.io/ "Hugo website"), a static site generator built with Go.

### Installing Hugo
Hugo is available on most modern operating systems. If you're using a GNU/Linux distribution that uses the `apt` package manager (Debian, Ubuntu or any of their derivatives) you can install it with the following command:

``` sh
sudo apt install hugo
```
If you're using a GNU/Linux distribution that uses the `pacman` package manager (Archlinux or any of it's derivatives) you can use the following command:

``` sh
sudo pacman -S hugo
```
If you're using a Distro that uses the dnf package manger (Fedora) you can use the following command:

``` sh
sudo dnf install hugo
```
### Running a development server
To run a development server run the following command:

``` sh
hugo server -D
```
If you want your server to show your draft posts to run:

``` sh
hugo server -D --buildDrafts
```
### Generating Static Sites
To generate static websites, just run the command `hugo` from the command line from the project's root folder where the config.toml file is present.
This will generate the files in a directory called `public`. These files can now be deployed using a web server of your choice.

### To add a news/announcement:

1. Run `hugo new news/title-of-the-news-item.md`.
1. A new markdown file will be created under `content/news/` directory. Use your favourite text editor to edit it.
1. To see website preview, run `hugo server -D` and open `localhost:1313` in your browser.
1. When you finish drafting the news item, to make it live, change `draft: true` to `draft: false` in the above created markdown file.

### Workflow for camp.fsci.in
- Make necessary changes and commit the changes to git.
- Push to git.fosscommunity.in
- Raise merge request

### How to update website in production
- First you need ssh access to the server ([contact](https://camp.fsci.in/#contact) the camp team for the same).
- Run the `update-camp-website` script in the home folder of the server to get the latest changes in master deployed to production. (You can run this in a single command with `ssh $CONNECTIONSTRING -t "./update-camp-website"` where $CONNECTIONSTRING is the parameters for the ssh connection.)